<?php
session_start();
if (!isset($_SESSION['admin'])) {
    $error = null; 

    if ($_SERVER['REQUEST_METHOD'] === 'POST') {
        $password = $_POST['password'] ?? '';
        $captcha = $_POST['captcha'] ?? '';

        if (!isset($_SESSION['captcha']) || $captcha != $_SESSION['captcha']) {
            $error = '验证码错误';
        } elseif ($password === 'nhu5jkuk') { 
            $_SESSION['admin'] = true;
            header('Location: admin.php');
            exit;
        } else {
            $error = '密码错误';
        }
    }

    $num1 = rand(1, 100);
    $num2 = rand(1, 100);
    $_SESSION['captcha'] = $num1 + $num2;

    ?>
    <!DOCTYPE html>
    <html lang="zh-CN">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>登录</title>
        <style>
            body {
                font-family: 'Segoe UI', system-ui, -apple-system, sans-serif;
                background: linear-gradient(135deg, #2ecc71, #3498db);
                margin: 0;
                padding: 0;
                display: flex;
                justify-content: center;
                align-items: center;
                height: 100vh;
                color: #2c3e50;
            }

            .login-container {
                background: rgba(255, 255, 255, 0.95);
                padding: 40px;
                border-radius: 16px;
                box-shadow: 0 8px 32px rgba(0, 0, 0, 0.1);
                width: 100%;
                max-width: 400px;
                text-align: center;
            }

            .login-container h1 {
                margin-bottom: 20px;
                font-size: 1.8em;
                color: #2c3e50;
            }

            .login-container input {
                width: 100%;
                padding: 12px;
                margin-bottom: 20px;
                border: 1px solid #ddd;
                border-radius: 8px;
                font-size: 1em;
                outline: none;
                transition: border-color 0.3s ease;
            }

            .login-container input:focus {
                border-color: #2ecc71;
            }

            .login-container button {
                width: 100%;
                padding: 12px;
                background: #2ecc71;
                color: white;
                border: none;
                border-radius: 8px;
                font-size: 1em;
                cursor: pointer;
                transition: background 0.3s ease;
            }

            .login-container button:hover {
                background: #27ae60;
            }

            .error-message {
                color: #e74c3c;
                margin-bottom: 20px;
                font-size: 0.9em;
            }

            .captcha {
                display: flex;
                align-items: center;
                justify-content: space-between;
                margin-bottom: 20px;
            }

            .captcha span {
                font-size: 1.2em;
                font-weight: bold;
                color: #2c3e50;
            }
        </style>
    </head>
    <body>
        <div class="login-container">
            <h1>登录</h1>
            <?php if ($error): ?>
                <div class="error-message"><?= htmlspecialchars($error) ?></div>
            <?php endif; ?>
            <form method="post">
                <input type="password" name="password" placeholder="输入密码..." required>
                <div class="captcha">
                    <span><?= $num1 ?> + <?= $num2 ?> = ?</span>
                    <input type="text" name="captcha" placeholder="输入计算结果..." required>
                </div>
                <button type="submit">登录</button>
            </form>
        </div>
    </body>
    </html>
    <?php
    exit;
}
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $data = json_decode(file_get_contents('php://input'), true);
    
    // 撤回消息
    if ($data['action'] === 'delete') {
        $messages = json_decode(file_get_contents('../sq/xx.json'), true);
        $messages = array_filter($messages, fn($m) => $m['id'] !== $data['id']);
        file_put_contents('../sq/xx.json', json_encode(array_values($messages)));
        echo json_encode(['status' => 'success']);
        exit;
    }
    
    // 禁言/解禁用户
    if ($data['action'] === 'ban' || $data['action'] === 'unban') {
        $blacklist = json_decode(file_get_contents('../sq/blacklist.json'), true) ?: [];
        if ($data['action'] === 'ban') {
            array_push($blacklist, $data['userId']);
        } else {
            $blacklist = array_diff($blacklist, [$data['userId']]);
        }
        file_put_contents('../sq/blacklist.json', json_encode(array_unique($blacklist)));
        echo json_encode(['status' => 'success']);
        exit;
    }

    // 发送官方消息
    if ($data['action'] === 'sendOfficial') {
        $messages = json_decode(file_get_contents('../sq/xx.json'), true) ?: [];
        
        $newMessage = [
            'id' => uniqid(),
            'userId' => 'SYSTEM',
            'text' => htmlspecialchars($data['message']),
            'time' => date('H:i'),
            'timestamp' => time(),
            'isOfficial' => true
        ];
        
        array_push($messages, $newMessage);
        file_put_contents('../sq/xx.json', json_encode($messages));
        echo json_encode(['status' => 'success']);
        exit;
    }

    // 模拟用户发送消息
    if ($data['action'] === 'simulateUser') {
        $messages = json_decode(file_get_contents('../sq/xx.json'), true) ?: [];
        
        $newMessage = [
            'id' => uniqid(),
            'userId' => htmlspecialchars($data['userId']),
            'text' => htmlspecialchars($data['message']),
            'time' => date('H:i'),
            'timestamp' => time(),
            'isOfficial' => false
        ];
        
        array_push($messages, $newMessage);
        file_put_contents('../sq/xx.json', json_encode($messages));
        echo json_encode(['status' => 'success']);
        exit;
    }

    // 一键清除所有消息
    if ($data['action'] === 'clearAllMessages') {
        file_put_contents('../sq/xx.json', json_encode([]));
        echo json_encode(['status' => 'success']);
        exit;
    }

    // 添加敏感词
    if ($data['action'] === 'addSensitiveWord') {
        $mgc = json_decode(file_get_contents('../sq/mgc.json'), true) ?: [];
        array_push($mgc, htmlspecialchars($data['word']));
        file_put_contents('../sq/mgc.json', json_encode(array_unique($mgc)));
        echo json_encode(['status' => 'success']);
        exit;
    }
}

// 获取数据
$messages = json_decode(file_get_contents('../sq/xx.json'), true) ?: [];
$blacklist = json_decode(file_get_contents('../sq/blacklist.json'), true) ?: [];
$mgc = json_decode(file_get_contents('../sq/mgc.json'), true) ?: [];
?>

<!DOCTYPE html>
<html lang="zh-CN">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>e chat-后台</title>
    <style>
        body {
            font-family: 'Segoe UI', system-ui, -apple-system, sans-serif;
            background: #f8f9fa;
            margin: 0;
            padding: 0;
            color: #2c3e50;
        }

        .admin-panel {
            max-width: 1200px;
            margin: 20px auto;
            padding: 20px;
            background: white;
            border-radius: 8px;
            box-shadow: 0 2px 10px rgba(0, 0, 0, 0.1);
        }

        .admin-panel h1 {
            margin-top: 0;
        }

        .action-section {
            margin: 20px 0;
            padding: 15px;
            background: #f8f9fa;
            border-radius: 8px;
        }

        .action-section h2 {
            margin-top: 0;
        }

        .action-section input {
            padding: 10px;
            margin-right: 10px;
            border: 1px solid #ddd;
            border-radius: 4px;
        }

        .action-section button {
            padding: 10px 20px;
            background: #3498db;
            color: white;
            border: none;
            border-radius: 4px;
            cursor: pointer;
        }

        .action-section button.danger {
            background: #e74c3c;
        }

        .sensitive-words-list {
            margin-top: 10px;
            padding: 10px;
            background: #fff;
            border: 1px solid #ddd;
            border-radius: 4px;
        }

        .admin-table {
            width: 100%;
            border-collapse: collapse;
            margin-top: 20px;
        }

        .admin-table th, .admin-table td {
            padding: 12px;
            border: 1px solid #ddd;
            text-align: left;
        }

        .admin-table th {
            background-color: #f8f9fa;
            font-weight: 600;
        }

        .action-btn {
            padding: 6px 12px;
            border: none;
            border-radius: 4px;
            cursor: pointer;
            margin: 2px;
            font-size: 0.9em;
            transition: all 0.2s ease;
        }

        .delete-btn {
            background-color: #e74c3c;
            color: white;
        }

        .delete-btn:hover {
            background-color: #c0392b;
        }

        .ban-btn {
            background-color: #f1c40f;
            color: white;
        }

        .ban-btn:hover {
            background-color: #f39c12;
        }

        .unban-btn {
            background-color: #2ecc71;
            color: white;
        }

        .unban-btn:hover {
            background-color: #27ae60;
        }
    </style>
</head>
<body>
    <div class="admin-panel">
        <h1>e -chat 后台</h1>
        <a href="logout.php" style="float:right;">退出登录</a>
       
        <div class="action-section">
            <h2>发送官方消息</h2>
            <input type="text" id="officialMessage" placeholder="输入官方消息内容...">
            <button onclick="sendOfficialMessage()">发送官方消息</button>
        </div>

        <!-- 模拟用户发送消息 -->
        <div class="action-section">
            <h2>模拟用户发送消息</h2>
            <input type="text" id="simulateUserId" placeholder="输入用户ID...">
            <input type="text" id="simulateUserMessage" placeholder="输入消息内容...">
            <button onclick="simulateUserMessage()">模拟发送</button>
        </div>

        <!-- 添加敏感词 -->
        <div class="action-section">
            <h2>添加敏感词</h2>
            <input type="text" id="sensitiveWord" placeholder="输入敏感词...">
            <button onclick="addSensitiveWord()">添加</button>
            <div class="sensitive-words-list">
                <strong>当前敏感词：</strong>
                <?= implode(', ', $mgc) ?>
            </div>
        </div>

        <!-- 一键清除所有消息 -->
        <div class="action-section">
            <h2>一键清除所有消息</h2>
            <button class="danger" onclick="clearAllMessages()">清除所有消息</button>
        </div>

        <!-- 消息管理 -->
        <h2>消息管理</h2>
        <table class="admin-table">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>用户</th>
                    <th>内容</th>
                    <th>时间</th>
                    <th>操作</th>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($messages as $msg): ?>
                <tr>
                    <td><?= htmlspecialchars($msg['id']) ?></td>
                    <td><?= htmlspecialchars($msg['userId']) ?></td>
                    <td><?= htmlspecialchars($msg['text']) ?></td>
                    <td><?= htmlspecialchars($msg['time']) ?></td>
                    <td>
                        <button class="action-btn delete-btn" 
                                onclick="deleteMessage('<?= $msg['id'] ?>')">撤回</button>
                    </td>
                </tr>
                <?php endforeach; ?>
            </tbody>
        </table>

        <!-- 用户管理 -->
        <h2>用户管理</h2>
        <?php
        $users = array_unique(array_column($messages, 'userId'));
        ?>
        <table class="admin-table">
            <thead>
                <tr>
                    <th>用户ID</th>
                    <th>状态</th>
                    <th>操作</th>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($users as $user): ?>
                <tr>
                    <td><?= htmlspecialchars($user) ?></td>
                    <td><?= in_array($user, $blacklist) ? '已禁言' : '正常' ?></td>
                    <td>
                        <?php if (in_array($user, $blacklist)): ?>
                            <button class="action-btn unban-btn" 
                                    onclick="manageUser('<?= $user ?>', 'unban')">解禁</button>
                        <?php else: ?>
                            <button class="action-btn ban-btn" 
                                    onclick="manageUser('<?= $user ?>', 'ban')">禁言</button>
                        <?php endif; ?>
                    </td>
                </tr>
                <?php endforeach; ?>
            </tbody>
        </table>
    </div>

    <script>
        // 发送官方消息
        async function sendOfficialMessage() {
            const input = document.getElementById('officialMessage');
            const message = input.value.trim();
            
            if (!message) {
                alert('请输入消息内容');
                return;
            }

            try {
                const response = await fetch('admin.php', {
                    method: 'POST',
                    headers: {'Content-Type': 'application/json'},
                    body: JSON.stringify({
                        action: 'sendOfficial',
                        message: message
                    })
                });
                const result = await response.json();
                if (result.status === 'success') {
                    alert('官方消息发送成功！');
                    location.reload();
                } else {
                    alert('发送失败！');
                }
            } catch (error) {
                console.error('发送失败:', error);
                alert('发送失败！');
            }
        }

        // 模拟用户发送消息
        async function simulateUserMessage() {
            const userId = document.getElementById('simulateUserId').value.trim();
            const message = document.getElementById('simulateUserMessage').value.trim();
            
            if (!userId || !message) {
                alert('请输入用户ID和消息内容');
                return;
            }

            try {
                const response = await fetch('admin.php', {
                    method: 'POST',
                    headers: {'Content-Type': 'application/json'},
                    body: JSON.stringify({
                        action: 'simulateUser',
                        userId: userId,
                        message: message
                    })
                });
                const result = await response.json();
                if (result.status === 'success') {
                    alert('模拟消息发送成功！');
                    location.reload();
                } else {
                    alert('发送失败！');
                }
            } catch (error) {
                console.error('发送失败:', error);
                alert('发送失败！');
            }
        }

        // 添加敏感词
        async function addSensitiveWord() {
            const word = document.getElementById('sensitiveWord').value.trim();
            
            if (!word) {
                alert('请输入敏感词');
                return;
            }

            try {
                const response = await fetch('admin.php', {
                    method: 'POST',
                    headers: {'Content-Type': 'application/json'},
                    body: JSON.stringify({
                        action: 'addSensitiveWord',
                        word: word
                    })
                });
                const result = await response.json();
                if (result.status === 'success') {
                    alert('敏感词添加成功！');
                    location.reload();
                } else {
                    alert('添加失败！');
                }
            } catch (error) {
                console.error('添加失败:', error);
                alert('添加失败！');
            }
        }

        // 一键清除所有消息
        async function clearAllMessages() {
            if (!confirm('确定要清除所有消息吗？此操作不可恢复！')) return;
            
            try {
                const response = await fetch('admin.php', {
                    method: 'POST',
                    headers: {'Content-Type': 'application/json'},
                    body: JSON.stringify({
                        action: 'clearAllMessages'
                    })
                });
                const result = await response.json();
                if (result.status === 'success') {
                    alert('所有消息已清除！');
                    location.reload();
                } else {
                    alert('清除失败！');
                }
            } catch (error) {
                console.error('清除失败:', error);
                alert('清除失败！');
            }
        }

        // 撤回消息
        async function deleteMessage(id) {
            if (!confirm('确定要撤回这条消息吗？')) return;
            
            try {
                const response = await fetch('admin.php', {
                    method: 'POST',
                    headers: {'Content-Type': 'application/json'},                
                    
                     body: JSON.stringify({
                        action: 'delete',
                        id: id
                    })
                });
                const result = await response.json();
                if (result.status === 'success') {
                    alert('消息已撤回！');
                    location.reload();
                } else {
                    alert('撤回失败！');
                }
            } catch (error) {
                console.error('撤回失败:', error);
                alert('撤回失败！');
            }
        }

        async function manageUser(userId, action) {
            const actionText = action === 'ban' ? '禁言' : '解禁';
            if (!confirm(`确定要${actionText}该用户吗？`)) return;
            
            try {
                const response = await fetch('admin.php', {
                    method: 'POST',
                    headers: {'Content-Type': 'application/json'},
                    body: JSON.stringify({
                        action: action,
                        userId: userId
                    })
                });
                
                const result = await response.json();
                if (result.status === 'success') {
                    alert(`用户已${actionText}！`);
                    location.reload();
                } else {
                    alert(`${actionText}失败！`);
                }
            } catch (error) {
                console.error(`${actionText}失败:`, error);
                alert(`${actionText}失败！`);
            }
        }
    </script>
</body>
</html>