<?php
// 禁用错误输出
error_reporting(0);
ini_set('display_errors', 0);

// 清空缓冲区
while (ob_get_level()) ob_end_clean();

header('Content-Type: application/json; charset=utf-8');
header('Access-Control-Allow-Origin: *');

try {
    // 读取敏感词库
    $mgc = @json_decode(file_get_contents('../sq/mgc.json'), true) ?: [];
    $blacklist = @json_decode(file_get_contents('../sq/blacklist.json'), true) ?: [];

    // 获取输入数据
    $input = file_get_contents('php://input');
    $data = json_decode($input, true);

    if (json_last_error() !== JSON_ERROR_NONE) {
        throw new Exception('无效的 JSON 数据');
    }

    // 敏感词检测
    foreach ($mgc as $word) {
        if (stripos($data['text'], $word) !== false) {
            echo json_encode(['status' => 'error', 'msg' => '包含敏感词']);
            exit;
        }
    }

    // 禁言检测
    if (in_array($data['userId'], $blacklist)) {
        echo json_encode(['status' => 'error', 'msg' => '你已被禁言']);
        exit;
    }

    // 生成消息
    $message = [
        'id' => uniqid(),
        'userId' => $data['userId'],
        'text' => htmlspecialchars($data['text']),
        'time' => date('H:i'),
        'timestamp' => time(),
        'isOfficial' => $data['isOfficial'] ?? false
    ];

    // 保存消息
    $messages = @json_decode(file_get_contents('../sq/xx.json'), true) ?: [];
    array_push($messages, $message);
    file_put_contents('../sq/xx.json', json_encode($messages, JSON_UNESCAPED_UNICODE));

    echo json_encode(['status' => 'success'], JSON_UNESCAPED_UNICODE);
} catch (Exception $e) {
    echo json_encode(['status' => 'error', 'msg' => $e->getMessage()]);
}